var interpret = {
    init: function() {
        var _this = this;
        _this.lastValue;
        _this.selRange;
        _this.isResume = false;
        // 长按选词
        (function() {
            // var index = 0;
            function postSelectionChange() {
                //所有高亮取消
                $("#sentenceContainer .bs").removeClass("bs");
                console.log("postSelectionChange");
                console.log(window.getSelection());
                console.log(window.getSelection().toString());
                console.log(_this.lastValue != window.getSelection().toString());
                if (window.getSelection().toString() && _this.lastValue != window.getSelection().toString()) {
                    var rect = interpret.getSelectionRect();
                    // document.querySelector(".super-headword-container").innerHTML = JSON.parse(rect).content + (index++);
                    _this.lastValue = window.getSelection().toString();
                    _this.selRange = window.getSelection().getRangeAt(0);
                    console.log("rect:" + rect);
                    window.jsInterface.execute("cmd=selection_change&rect="+rect);
                } else {
                    _this.lastValue = "";
                }
            }
            // selectionChange
            var moveTimer = null;
            function selectionChange() {
                if (_this.isResume) {
                    setTimeout(function() {
                        _this.isResume = false;
                    }, 100);
                    return;
                }
                moveTimer && (clearTimeout(moveTimer));
                moveTimer = setTimeout(function() {
                    postSelectionChange();
                }, 300);
            }
            document.addEventListener("selectionchange", selectionChange, false);
            document.addEventListener("touchstart", function() {
                console.log("touchstart...");
                window.getSelection().removeAllRanges();
                document.removeEventListener("selectionchange", selectionChange, false);
                if (window.navigator.userAgent.match(/Android 8/)) {
                    document.addEventListener("selectionchange", fixPixel, false);
                }
            });
            document.addEventListener("touchmove", function() {
                console.log("touchmove...");
                document.removeEventListener("selectionchange", selectionChange, false);
            });
            document.addEventListener("touchend", function(ev) {
                console.log("touchend...");
                interpret.doTouchEnd();
            });
            interpret.doTouchEnd = function() {
                console.log("dotouchend...");
                postSelectionChange();
                document.addEventListener("selectionchange", selectionChange, false);
                if (window.navigator.userAgent.match(/Android 8/)) {
                    document.removeEventListener("selectionchange", fixPixel, false);
                }
            }
            // fix pixel android8.0机器中的 12个空格导致全选bug(通过模拟 - 屏蔽第二次的全选事件)
            var lastTime;
            var lastRange;
            function fixPixel(ev) {
                var now = (new Date()).valueOf();
                var selection = window.getSelection();
                if (selection.rangeCount !== 1) {
                    return;
                }
                var range = selection.getRangeAt(0);
                var text = range.toString();
                var matches = text.match(/\s/);
                console.log("=====gap" + (now - lastTime) + "========");
                console.log(window.getSelection().toString());
                if (lastTime && (now - lastTime) < 300) {
                    if (matches && lastRange) {
                        selection.removeAllRanges();
                        selection.addRange(lastRange);
                    } else if (matches) {
                        selection.removeAllRanges();
                    }
                } else if (matches) {
                    selection.removeAllRanges();
                };
                lastTime = now;
                if (!matches) {
                    lastRange = range;
                    return;
                }
            }
        })()
        // 播放例句
        $(document).on("tap", ".sentence-wrap", function() {
            // $(this).addClass("on");
            var audioUrl = $(this).attr("data-audio");
            // window.webkit.messageHandlers.playSentence.postMessage(audioUrl);
            window.jsInterface.execute("cmd=play_sentence&audio="+audioUrl);
            console.log(audioUrl);
        });
        // 跳转课文
        $(document).on("tap", ".img-wrap", function() {
            // window.location.href = "fake1://" + $(this).attr("data-sentid");
            // window.webkit.messageHandlers.playEpisodeBySent.postMessage($(this).attr("data-sentid"));
            window.jsInterface.execute("cmd=play_episode_by_sent&audio="+$(this).attr("data-sentid"));
            console.log($(this).attr("data-sentid"));
        });
    },
    render: function(json, offsetTop) {
        if (typeof json == "string") {
            json = JSON.parse(json);
        }
        // json.details && (json.collins = json.details);
        // console.log(json);
        var html = template("tpl", json);
        offsetTop && (document.querySelector("body").style.paddingTop = offsetTop + "px");
        document.querySelector("#sentenceContainer").innerHTML = html;
    },
    getSelectionRect: function() {
        var json = {};
        var oSelection = window.getSelection();
        if (oSelection.toString()) {
            var selectRect = oSelection.getRangeAt(0).getBoundingClientRect();
            var $sentense;
            var $selectParent = $(window.getSelection().anchorNode.parentNode);
            var $span;
            if ($selectParent.is(".sentence-wrap dt")) {
                $sentense = $selectParent;
            } else if ($selectParent.is(".sentence-wrap span")) {
                $sentense = $selectParent.parent();
                $span = $selectParent;
            } else if ($selectParent.is(".sentence-wrap b")) {
                $sentense = $selectParent.parent().parent();
                $span = $selectParent.parent();
            }
            if ($sentense) {
                json.top = $sentense.offset().top - $(window).scrollTop();
                json.left = $sentense.offset().left;
                json.right = json.left + $sentense.width();
                json.bottom = json.top + $sentense.height();
            }
            json.content = oSelection.toString();
            if (!!$sentense) {
                var $li = $sentense.parents("li");
                json.sentenseId = $li.attr("id");
                json.index = $("#sentenceContainer li").index($li);
            }
            // if ($span && ($span.text() == json.content)) {
            //     if ($span.is("span")) {
            //         json.spanid = $span.attr("id");
            //     } else {
            //         json.spanid = $span.parent().attr("id");
            //     }
            //     $("#" + json.spanid).addClass("bs");
            // }
            return JSON.stringify(json);
        }
    },
    removeSelection: function() {
        interpret.lastValue = "";
        window.getSelection().removeAllRanges();
    },
    resumeSelection: function() {
        window.getSelection().removeAllRanges();
        interpret.isResume = true;
        window.getSelection().addRange(interpret.selRange);
    },
    setHeadGap: function(iGap) {
        document.querySelector("body").style.paddingTop = iGap + "px";
    },
    showTip: function() {
        document.querySelector("#tipWrap").style.display = "block";
    },
    hideTip: function() {
        document.querySelector("#tipWrap").style.display = "none";
    },
    // 设置高亮
    activeSentenceHighLight: function(sentenceId) {
        $("#sentenceContainer li").removeClass("on");
        $("#" + sentenceId).addClass("on");
    },
    // 取消高亮
    negativeSentenceHighLight: function() {
        $("#sentenceContainer li").removeClass("on");
    },
    setFootGap: function(iGap) {
        document.querySelector("body").style.paddingBottom = iGap + "px";
    },
    //设置主题
    setTheme: function(theme) {
        $("body").attr("class", "").addClass(theme);
    },
    // 设置字体
    setFontFamily: function(fontFamily) {
        if (fontFamily == "Hind-Medium") {
            $("#fontFamily").text(".sentence-wrap dt{font-family: " + fontFamily + ";} .sentence-wrap dt b{font-family: Hind-Bold;font-weight: normal;}");
            return
        }
        $("#fontFamily").text(".sentence-wrap dt{font-family: " + fontFamily + ";}");
    }
};
interpret.init();
