"use strict";

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

/**
 * 基础工具类
 */
var BaseUtil = {
  apiHost: "https://langeasy.com.cn",
  imgCdn: "https://img.beingfine.cn",
  LANGEASY_APP_NAME: "langeasy",
  QLISTEN_APP_NAME: "qlisten",
  LEXIS_APP_NAME: "lexis",
  checkAppName: function checkAppName() {
    // 检查应用名称,因为lexis可能是langeasyLexis，所以langeasy判断一定要放到最后
    var userAgent = window.navigator.userAgent;
    var checkAppNameList = [BaseUtil.QLISTEN_APP_NAME, BaseUtil.LEXIS_APP_NAME, BaseUtil.LANGEASY_APP_NAME];
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = checkAppNameList[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var appName = _step.value;

        if (new RegExp(appName, "i").test(userAgent)) {
          return appName;
        }
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    return "";
  }
};
var common = {
  //设置sid
  setSid: function setSid(sid) {
    this.sid = decodeURIComponent(sid);
  }
};
//数组排序
Array.prototype.unique3 = function () {
  // 构建一个新数组存放结果
  var newArray = [];
  // 创建一个空对象
  var object = {};
  // for循环时，每次取出一个元素与对象进行对比
  // 如果这个元素不重复，则将它存放到结果数中
  // 同时把这个元素的内容作为对象的一个属性，并赋值为1,
  // 存入到第2步建立的对象中
  for (var i = 0; i < this.length; i++) {
    // 检测在object对象中是否包含遍历到的元素的值
    if (!object[_typeof(this[i]) + this[i]]) {
      // 如果不包含，将存入对象的元素的值推入到结果数组中
      newArray.push(this[i]);
      // 如果不包含，存入object对象中该属性名的值设置为1
      object[_typeof(this[i]) + this[i]] = 1;
    }
  }
  return newArray;
};
$(function () {
  // 页面启动
  var $body = $("body");
  var appName = BaseUtil.checkAppName();
  console.log({ appName: appName });
  $body.addClass(appName);
});
var episode = {
  // 加载效率 定时 + 滚动
  //_检查 应用在客户端的bug
  //_没有划分私方法、属性与公用方法、属性
  // 使用iframe加载媒体标签
  _init: function _init() {
    var _this = this;

    var that = this;
    var $body = $("body");
    var CLIENT_BAR_HEIGHT = 56;
    var defaultAlbumCover = "public/images/defaultAlbumCover.jpg";
    this.LEXIS_APP_NAME = "lexis";
    this.LANGEASY_APP_NAME = "langeasy";
    this.QLISTEN_APP_NAME = "qlisten";
    this.SELECTION_SPAN_CLASS = "selection";
    this.theme = "light"; //默认主题
    this.followReadingCover = ""; //跟读封面
    this.lrcType = 1; // 0无课文 1有课文
    // 获取appname
    if (/lexis/gi.test(window.navigator.userAgent)) {
      this.appName = this.LEXIS_APP_NAME;
    } else if (/langeasy/gi.test(window.navigator.userAgent)) {
      this.appName = this.LANGEASY_APP_NAME;
    } else {
      this.appName = this.QLISTEN_APP_NAME;
    }
    // 点击收藏例句
    var CMD_FAVOR_SENTENCE = "favor_sentence"; // cmd=favor_sentence&action=favor|cancel&segid=xxx
    that._initFavorite = function () {
      console.log("_initFavorite");
      $(".favorite-btn").on("click", function (event) {
        console.log(".favorite-btn");
        var $parent = $(this).parent();
        var segid = $parent.attr("id");
        var action = $parent.hasClass("favorite") ? "cancel" : "favor";
        that.executeCmdParam(CMD_FAVOR_SENTENCE, { action: action, segid: segid });
        event.stopPropagation(); //  阻止事件冒泡
      });
    };
    that.setLrcType = function (type) {
      that.lrcType = type;
      $("#mainContainer").addClass("lrctype" + type);
    };
    //计算封面尺寸
    that._getCoverSize = function () {
      // 封面为正方形，中间空白部分减去（24+32），当这个数字 - 屏幕宽度减去-32时，如图1，那么正方行的边长=中间空白部分-（24+32）；
      // 如果空白部分-（24+32）大于屏幕宽度-32，如图2，那么正方形边长为屏幕宽度-32，且距离标题24
      var IMAGE_HEIGHT_GAP = 52 + 16 + 16 + 24 + 32 + CLIENT_BAR_HEIGHT + $("#playerHeader").height();
      var IMAGE_WIDTH_GAP = 48;
      // var MAX_SIZE = 325;
      var iWinHeight = document.documentElement.clientHeight;
      var iWinWidth = document.documentElement.clientWidth;
      var imageSize;
      if (iWinHeight - IMAGE_HEIGHT_GAP > iWinWidth - IMAGE_WIDTH_GAP) {
        imageSize = iWinWidth - IMAGE_WIDTH_GAP;
      } else {
        imageSize = iWinHeight - IMAGE_HEIGHT_GAP;
      }
      return imageSize;
      // return imageSize >= MAX_SIZE ? MAX_SIZE : imageSize;
    };
    // var visibleNum = 2;
    // var intervalTime = 3000;
    // var intervalTime = 30;
    //渲染课文
    that._renderCourse = function (data) {
      console.log(data, "_renderCourse data");
      // 课文尾部的富媒体（版权信息、微博链接、相关课程、相关教材、名师精讲）应该从分享模块向上布局。
      (function () {
        var oBottom = {
          segments: []
        };
        var segments = data.segments;
        var allSegments = $.extend(segments);
        for (var i = allSegments.length; i > 0; i--) {
          var oLine = allSegments[i - 1];
          if (oLine.type === "share") {
            // 废弃share模块
            segments.pop();
          } else if (oLine.type === "action") {
            // action在末端放到底部
            oBottom.segments.unshift(segments.pop());
          } else if (oLine.type === "inline-obj") {
            // 非图片、非视频、非音频
            if (!oLine.tags.match(/<banner-image/) && !oLine.tags.match(/banner-video/) && !oLine.tags.match(/banner-audio/) && !oLine.tags.match(/<iframe/)) {
              oBottom.segments.unshift(segments.pop());
            } else {
              break;
            }
          } else if (oLine.type === "text") {
            // text可能与正文有关所以不排除 与正文无关的例如 含有@符号
            if (oLine.tags.match(/©/)) {
              oBottom.segments.unshift(segments.pop());
            } else {
              break;
            }
          } else {
            break;
          }
        }
        // console.log("oBottom========");
        console.log(oBottom, "oBottom");
        var $mediaContent = $("#mediaContent");
        var mediaHtml = template("course_tpl", oBottom);
        $mediaContent.html(mediaHtml);
      })();
      if (data.segments) {
        var aIntroduction = data.segments.filter(function (v) {
          return v.type === "introduction";
        });
        if (aIntroduction && aIntroduction.length > 0) {
          $("#introduction").html(aIntroduction[0].tags).show();
        } else {
          $("#introduction").hide();
        }
      }
      // 渲染顶部
      var $playerContent = $("#playerContent");
      var playerHtml = template("course_tpl", data);
      $playerContent.html(playerHtml);
      setTimeout(function () {
        console.log("renderTime:" + (new Date().valueOf() - that.startTime));
      }, 0);
      //让视频能播放
      $(".banner-video").each(function () {
        $(this).bannerPlayer();
      });
      $(".banner-audio").each(function () {
        $(this).bannerPlayer({
          type: "audio"
        });
      });
      //IFRAME拦截
      $(".module iframe").each(function () {
        var $parent = $(this).parent();
        $parent.append("<i class='iframe-mask'></i>");
      });
      //动态加载课程与教材信息
      // that._loadEpisode();
      // that._loadCourse();
      that._loadCourseEpisode();
      that._initFavorite();
      console.log("_renderCourse");
      // 增加微信播放器
      that.addMpvoiceEvent();
      // }
    };
    //初始化页面
    that.clearScreen = function () {
      var initHtml = template("init_tpl", {});
      $body.html(initHtml);
      this.followReadingCover = ""; //跟读封面
    };
    //加载封面
    that.loadCover = function (extra) {
      this.startTime = new Date().valueOf();
      if (extra.font) {
        that.setFontLevel(extra.font);
      }
      that.clearScreen();;
      that._setWrapHeight();
      $("#playerTitle span").html(extra.title);
      if (extra.subtitle) {
        $("#playerSubtitle").html(extra.subtitle).show();
      }
      setTimeout(function () {
        extra.coverSize = that._getCoverSize();
        var html = template("cover_tpl", extra);
        // $("#playerTitleHelper span").html(extra.title);
        $("#coverContent").html(html);
        $("#mainContainer").removeClass("both en cn title cover");
      }, 0);
      setTimeout(function () {
        $("#shareModule").show();
      }, 100);
    };
    //插入segments
    that.renderSegments = function (data, mySentences, showTips) {
      //客户端占位符
      window.langeasy && window.langeasy.courseContentLoaded();;
      that.episodeData = data;
      console.log(data, "renderSegments处理之前啊");
      var newData = that._thansformSegments(data);
      console.log(newData, "renderSegments处理之后newData");
      that._renderCourse(newData);
      $("#sentenceTips").removeClass("none both sentence word").addClass(showTips);
      mySentences.forEach(function (v) {
        var $sentece = $("#" + v);
        $sentece.addClass("favorite");
      });
      setTimeout(function () {
        window.langeasy && window.langeasy.renderContentDone();
      }, 0);
    };
    //动态加载教材课程信息
    that._loadCourseEpisode = function () {
      var episodes = [];
      var courses = [];
      $("[load-episode]").each(function () {
        episodes.push($(this).attr("load-episode"));
      });
      $("[load-course]").each(function () {
        courses.push($(this).attr("load-course"));
      });
      if (!episodes.length && !courses.length) {
        return;
      }
      /*<jdists trigger="debug">
            common.sid = "k0t5CNBsU5HsDeh%2FFXhqGnxTAS7A3EQQPX%2FcKZOXLepiuZIpFhLm35pUH2iY+xvbY3TasQ1jEPzm%2Bp%2FOGr4%2FXt1o%2FY4Zsy9O85tdyxC3cwOUtuIh6K5xgg8%2F5+U5RdeTRe8AKlJMo8jMI%3D";
            var url = "https://sapi.beingfine.cn/v1/LE_GetCoursesAndEpisodes?version=1.0&udid=udid&app_id=600000002&sid=" + common.sid;
                </jdists>*/
      var url = "https://sapi.beingfine.cn/v1/LE_GetCoursesAndEpisodes?version=1.0&udid=udid&app_id=600000002&sid=" + common.sid;
      /*<jdists trigger="ios">
            var url = "https://sapi.beingfine.cn/v1/LE_GetCoursesAndEpisodes?version=1.0&udid=udid&app_id=600000002&sid=" + encodeURIComponent(common.sid);
            </jdists>*/
      $.get(url, {
        episode_id_list: episodes.unique3().toString(),
        course_id_list: courses.unique3().toString()
      }, function (res) {
        var data = res.data_body;
        //   console.log("data.episodes");
        var oEpisode = {};
        var oCourse = {};
        var oRefCourses = {};
        data.episodes && data.episodes.forEach(function (ep) {
          oEpisode[ep.episode_id] = ep;
        });
        data.courses && data.courses.forEach(function (co) {
          oCourse[co.course_id] = co;
        });
        data.ref_courses && data.ref_courses.forEach(function (co) {
          oRefCourses[co.course_id] = co;
        });
        //   console.log({
        //     oEpisode
        //   });
        //   console.log({
        //     oCourse
        //   });
        $("[load-episode]").each(function () {
          var episodeId = $(this).attr("load-episode");
          var ep = oEpisode[episodeId];
          if (ep) {
            var $that = $(this);
            var course = oRefCourses[ep["course_id"]];
            // ep.course = course;
            var coverImg = ep["image_file_name"] != "*" ? ep["image_file_name"] : course["image_file_name"];
            // ep["image_file_name"] = coverImg;
            coverImg = coverImg != "*" ? coverImg : defaultAlbumCover;
            coverImg = "https://img.beingfine.cn/" + coverImg + "?x-oss-process=image/resize,w_80";
            $that.find("img").attr("src", coverImg);
            $that.find(".episode-title").html(ep["episode_title"]);
            $that.find(".episode-info").html(course["course_title"]);
            // ep["cmd"] = "open_episode";
            // var par = JSON.stringify(ep);
            var oCmd = {
              cmd: "open_episode",
              episode: JSON.stringify(ep),
              course: JSON.stringify(course)
            };
            $that.attr("to-client", JSON.stringify(oCmd));
            $that.css("display", "-webkit-box");
            $that.parent("dl").show();
          }
        });
        $("[load-course]").each(function () {
          var courseId = $(this).attr("load-course");
          var co = oCourse[courseId];
          if (co) {
            var $that = $(this);
            var coverImg = co["image_file_name"] != "*" ? co["image_file_name"] : defaultAlbumCover;
            coverImg = "https://img.beingfine.cn/" + coverImg + "?x-oss-process=image/resize,w_80";
            $that.find("img").attr("src", coverImg);
            $that.find(".course-title").html(co["course_title"]);
            $that.find(".course-num").html(co["episode_count"]);
            var downloadTimes = co["download_times"];
            downloadTimes = parseInt(downloadTimes) / 10000 >= 1 ? Math.floor(parseInt(downloadTimes) / 10000) + "万+" : downloadTimes;
            $that.find(".sub-num").html(downloadTimes);
            var oCmd = { cmd: "open_course", course: JSON.stringify(co) };
            $that.attr("to-client", JSON.stringify(oCmd));
            // co["cmd"] = "open_course";
            // var par = JSON.stringify(co);
            // $that.attr("to-client", par);
            $that.css("display", "-webkit-box");
            $that.parent("dl").show();
          }
        });
      });
    };
    //动态加载课程信息
    that._loadEpisode = function () {
      $("[load-episode]").each(function () {
        var episodeId = $(this).attr("load-episode");
        var $that = $(this);
        $.get(BaseUtil.apiHost + "/loadEpisodeInfo.action?episodeId=" + episodeId, function (data) {
          //   console.log("episodeData");
          //   console.log(data);
          // var data = {"course_image_file_name":"ListenData\/015153613977148221799\/015153613977148221799.png","audio_file_name":"01913403750134195676592425589021604.mp3","episode_id":"20120622222333100000001","episode_title":"lesson 003  Sorry, sir","audio_file_size":"1271","duration":"60","course_title":"anota creat","subtitle_type":"4","lrc_file_name":"01913403750134195676592425589021604.lrc","create_time":"20120622222333","quota_cost":1,"course_id":"015153613977148221799","locked":0,"image_file_name":"*","trial_duration":60};
          // 存在课程图片使用课程图片，存在教材图片使用教材图片
          var coverImg = data["image_file_name"] != "*" ? data["image_file_name"] : data["course_image_file_name"];
          data["image_file_name"] = coverImg;
          coverImg = coverImg != "*" ? coverImg : defaultAlbumCover;
          coverImg = "https://img.beingfine.cn/" + coverImg + "?x-oss-process=image/resize,w_80";
          $that.find("img").attr("src", coverImg);
          $that.find(".episode-title").html(data["episode_title"]);
          $that.find(".episode-info").html(data["course_title"]);
          delete data["course_image_file_name"];
          delete data["course_title"];
          data["cmd"] = "open_episode";
          var par = JSON.stringify(data);
          $that.attr("to-client", par);
          $that.css("display", "-webkit-box");
          $that.parent("dl").show();
        });
      });
    };
    //动态加载教材信息
    that._loadCourse = function () {
      $("[load-course]").each(function () {
        var courseId = $(this).attr("load-course");
        var $that = $(this);
        $.get(BaseUtil.apiHost + "/loadCourseInfo.action?courseId=" + courseId, function (data) {
          // var data = {"sort":"1","episode_count":"144","course_intro":"\t????????????????????????????????????????????????","course_title":"anota creat","lrc_count":"142","create_time":"20160422165229","locked":1,"download_times":"367009","res_base_path":"ListenData\/015153613977148221799\/","course_id":"015153613977148221799","update_count":"0","image_file_name":"ListenData\/015153613977148221799\/015153613977148221799.png"};
          var coverImg = data["image_file_name"] != "*" ? data["image_file_name"] : defaultAlbumCover;
          coverImg = "https://img.beingfine.cn/" + coverImg + "?x-oss-process=image/resize,w_80";
          $that.find("img").attr("src", coverImg);
          $that.find(".course-title").html(data["course_title"]);
          $that.find(".course-num").html(data["episode_count"]);
          var downloadTimes = data["download_times"];
          //   console.log("downloadTimes");
          //   console.log(parseInt(downloadTimes) / 10000);
          downloadTimes = parseInt(downloadTimes) / 10000 >= 1 ? Math.floor(parseInt(downloadTimes) / 10000) + "万+" : downloadTimes;
          $that.find(".sub-num").html(downloadTimes);
          data["cmd"] = "open_course";
          var par = JSON.stringify(data);
          $that.attr("to-client", par);
          $that.css("display", "-webkit-box");
          $that.parent("dl").show();
        });
      });
    };
    //设置高度
    that._setWrapHeight = function () {
      // var $playerContentWrap = $("#playerContentWrap");
      // var GAP_HEIGHT = 68 + 32 + 16 + CLIENT_BAR_HEIGHT;
      // var iUlHeight = document.documentElement.clientHeight - GAP_HEIGHT;
      // $playerContentWrap.css({ "minHeight": iUlHeight });
      $("#mainContainer").css("maxHeight", document.documentElement.clientHeight - CLIENT_BAR_HEIGHT);
    };
    //segments的数据转换 与 一些hack
    that._thansformSegments = function (data) {
      var json = {};
      var hasBannerVideo = false;
      data.segments.forEach(function (item) {
        if (item.tags.indexOf("banner-video")) {
          hasBannerVideo = true;
        }
      });
      if (!hasBannerVideo) {
        json.segid = "3-0-0-0";
        json.tags = '<div class="banner-video" style="width:100%;height:autoVideoHeight;"><video webkit-playsinline="" preload="preload" poster=""><source src="' + that.videoPath + '" type="video/mp4"></video><div class="extra-content"><div class="poster-wrap"></div><i class="bg"></i><a href="javascript:;" class="btn-player" active></a><div class="video-text">视频片段</div></div><div class="ctrl-content hide"><i class="btn-player" active></i><i active class="btn-fullScreen"></i><span class="elapse">0:00</span><input type="range" value="0" class="process-content"><span class="duration">0:00</span></div></div>';
        json.type = "inline-obj";
        data.segments.unshift(json);
      }
      data.segments.map(function (item) {
        if (item.type == "inline-obj") {
          //自适应高度 + cp简介换行只取一部分
          item.tags = item.tags.replace(/autoVideoHeight/g, that._getVideoHeight() + "px").replace(/(<p class="cp-info">.+)\n.+<\/p>/g, "$1</p>");
        }
        return item;
      });
      //share module hack
      return data;
    };
    //加载课文
    that.loadContents = function (data, form, extra) {
      // console.log("loadContents");
      // console.log(data);
      // console.log(extra);
      console.log("加载课文之前", data);
      var newData = that._thansformSegments(data);
      console.log(newData, "加载课文之后");
      newData.extra = extra;
      if (extra.font) {
        that.setFontLevel(extra.font);
      }
      $("#playerTitle span").html(extra.title);
      if (extra.subtitle) {
        $("#playerSubtitle").html(extra.subtitle).show();
      }
      $("#coverContent").hide();
      $("#mainContainer").addClass(form);
      that._renderCourse(newData);
      //客户端占位符
      window.langeasy && window.langeasy.courseContentLoaded();;
    };
    //切换双语字幕或封面 type:both en cn cover title
    that.transContent = function (type) {
      if (type === "en" || type === "cover" || type === "title") {
        that.hideTranslationSegment();
      }
      if (type === "cn" || type === "cover" || type === "title") {
        that.hideOriginSegment();
      }
      var $orig = $("#playerContent .orig-lrc");
      $orig.removeAttr("style");
      var $i18n = $("#playerContent .i18n-lrc");
      $i18n.removeAttr("style");
      setTimeout(function () {
        $("#mainContainer").removeClass("both en cn cover title").addClass(type);
      }, 0);
    };
    // 获取视频自适应高度
    that._getVideoHeight = function () {
      var MIN_HEIGHT = 164;
      var GAP_WEIGHT = 30;
      var SCALE = 9 / 16;
      var newHeight = (document.documentElement.clientWidth - GAP_WEIGHT) * SCALE;
      newHeight = newHeight > MIN_HEIGHT ? newHeight : MIN_HEIGHT;
      return newHeight;
    };
    // http://langeasytest:8090/pages/viewpage.action?pageId=2458242 实现改功能webview打开scheme
    that._goClient = function (url, scheme) {
      window.location.href = scheme;
      setTimeout(function () {
        window.location.href = url;
      }, 2000);
    };
    //old Functions
    that.getRectForSelectedText = function (idx) {
      if (!idx) {
        return;
      }
      var $el = document.getElementById(idx);
      if (!$el) {
        return;
      }
      var rect = $el.getBoundingClientRect();
      return "{{" + rect.left + "," + rect.top + "}, {" + rect.width + "," + rect.height + "}}";
    };
    //设置课文高亮（高亮当前句）
    that.setActiveSegment = function (segId, state) {
      var $li = $("#playerContent li");
      var $active = $(document.getElementById(segId));
      $li.removeClass("plain").removeClass("pinned");
      $active.addClass(state);
    };
    // 显示翻译的例句
    that.showTranslationSegment = function (segId) {
      //收起现在的句子
      // that.hideTranslationSegment();
      that.hideTranslationTimer && clearTimeout(that.hideTranslationTimer);
      that.showTranslationTimer && clearTimeout(that.showTranslationTimer);
      // 展开现在的句子
      var $active = $(".plain,.pinned");
      if (segId) {
        $active = $(document.getElementById(segId));
      }
      var $i18n = $active.find(".i18n-lrc").css("height", "auto").show();
      var iShowHeight = $i18n.height();
      $i18n.css({
        height: 0
      });
      setTimeout(function () {
        $i18n.css({
          transition: "300ms ease"
        });
      }, 0);
      setTimeout(function () {
        $i18n.css({
          height: iShowHeight
        });
        $active.addClass("trans").addClass("transing");
      }, 20);
      that.showTranslationTimer = setTimeout(function () {
        $i18n.css({
          height: "auto",
          transition: "0ms ease"
        });
      }, 300);
    };
    // 收起翻译例句
    that.hideTranslationSegment = function (segId) {
      that.hideTranslationTimer && clearTimeout(that.hideTranslationTimer);
      that.showTranslationTimer && clearTimeout(that.showTranslationTimer);
      var $active = $(".trans");
      var $i18n = $active.find(".i18n-lrc");
      var i18nHeight = $i18n.css("height", "auto").height();
      $i18n.css({
        height: i18nHeight
      });
      setTimeout(function () {
        $i18n.css({
          transition: "300ms ease"
        });
        if (segId) {
          $active = $(document.getElementById(segId));
        } else if (!$active.size()) {
          return;
        }
        $active.removeClass("trans").find(".i18n-lrc").css({
          height: 0
        });
        that.hideTranslationTimer && clearTimeout(that.hideTranslationTimer);
        that.hideTranslationTimer = setTimeout(function () {
          $active.removeClass("transing");
          $i18n.css({
            height: "auto",
            display: "",
            transition: "0ms ease"
          });
        }, 500);
      }, 40);
    };
    // 显示原文的例句
    that.showOriginSegment = function (segId) {
      //收起现在的句子
      // that.hideTranslationSegment();
      that.hideTranslationTimer && clearTimeout(that.hideTranslationTimer);
      that.showTranslationTimer && clearTimeout(that.showTranslationTimer);
      // 展开现在的句子
      var $active = $(".plain,.pinned");
      if (segId) {
        $active = $(document.getElementById(segId));
      }
      var $i18n = $active.find(".orig-lrc").css("height", "auto").show();
      var iShowHeight = $i18n.height();
      $i18n.css({
        height: 0
      });
      setTimeout(function () {
        $i18n.css({
          transition: "300ms ease"
        });
      }, 0);
      setTimeout(function () {
        $i18n.css({
          height: iShowHeight
        });
        $active.addClass("trans").addClass("transing");
      }, 20);
      that.showTranslationTimer = setTimeout(function () {
        $i18n.css({
          height: "auto",
          transition: "0ms ease"
        });
      }, 300);
    };
    // 收起翻译例句
    that.hideOriginSegment = function (segId) {
      that.hideTranslationTimer && clearTimeout(that.hideTranslationTimer);
      that.showTranslationTimer && clearTimeout(that.showTranslationTimer);
      var $active = $(".trans");
      var $i18n = $active.find(".orig-lrc");
      var i18nHeight = $i18n.css("height", "auto").height();
      $i18n.css({
        height: i18nHeight
      });
      setTimeout(function () {
        $i18n.css({
          transition: "300ms ease"
        });
        if (segId) {
          $active = $(document.getElementById(segId));
        } else if (!$active.size()) {
          return;
        }
        $active.removeClass("trans").find(".orig-lrc").css({
          height: 0
        });
        that.hideTranslationTimer && clearTimeout(that.hideTranslationTimer);
        that.hideTranslationTimer = setTimeout(function () {
          $active.removeClass("transing");
          $i18n.css({
            height: "auto",
            display: "",
            transition: "0ms ease"
          });
        }, 500);
      }, 40);
    };
    //获取当前点击元素信息
    that.getInfoAtPoint = function (x, y) {
      var $ele = $(document.elementFromPoint(x, y));
      var $segment = $ele.hasClass("segment") ? $ele : $ele.parents(".segment");
      var $share = $ele.hasClass("share-module") ? $ele : $ele.parents(".share-module");
      var $skip = $ele.hasClass("skip-episode-wrap") ? $ele : $ele.parents(".skip-episode-wrap");
      var json = {};
      if ($share.length) {
        json.t = "share";
        $ele = $ele.is(".btn") ? $ele.is(".btn") : $ele.parents(".btn");
        if ($ele.length) {
          json.id = $ele.attr("share-type");
        }
      } else if ($skip.length) {
        json.t = "skip-episode";
        $ele = $ele.is(".btn") ? $ele.is(".btn") : $ele.parents(".btn");
        if ($ele.length) {
          json.id = $ele.attr("type");
        }
      } else if ($segment.length) {
        if ($segment.hasClass("lrc")) {
          json.t = "subtitle";
          json.ln = $(".lrc").index($segment);
          if ($ele.is("span")) {
            var id = $ele.attr("id");
            json.wd = $ele.html();
            json.wid = id;
            if (that.appName === that.LEXIS_APP_NAME) {
              //只有不背单词才返回,只有不背单词才高亮选中
              that.markSpan(id, this.SELECTION_SPAN_CLASS);
            }
          }
        } else if ($segment.hasClass("action-module")) {
          json.t = "action";
          json.action = $segment.attr("action");
        } else if ($segment.hasClass("module")) {
          json.t = "inline";
        } else if ($segment.hasClass("banner-text")) {
          json.t = "txt";
        }
        json.segid = $segment.attr("id");
      } else if ($ele.is("#showEpisodeTips")) {
        // 显示课文
        json.t = "show-episode-content";
      } else {
        json.t = "outside";
      }
      //   console.log(json);
      return JSON.stringify(json);
    };
    // 叠加添加类
    function addClass($span, category) {
      var className = $span.attr("class");
      if (!className) {
        className = category;
      } else {
        className = className + " " + category;
      }
      $span.attr("class", className);
    }
    //标记span标签显示状态
    that.markSpan = function (ids, category) {
      var aId = ids.split("-");
      var spanID = void 0;
      if (category === that.SELECTION_SPAN_CLASS) {
        that.unmarkAllSpans(category);
      }
      if (aId.length === 2) {
        //两位id处理方式
        spanID = ids;
        var $span = $("#" + spanID);
        addClass($span, category);
      } else if (aId.length === 3) {
        var index = aId.pop();
        for (var i = 0; i < index; i++) {
          spanID = aId.join("-");
          //   console.log(spanID);
          var _$span = $("#" + spanID);
          addClass(_$span, category);
          aId[1]++;
        }
      }
    };
    // 删除class
    that._removeClass = function ($this, category) {
      $this.attr("class", function (index, className) {
        return className ? className.replace(new RegExp("(^|\\s)?" + category + "($|\\s)", "g"), "") : "";
      });
    };
    //标记span标签不高亮
    that.unmarkSpan = function (ids, category) {
      var aId = ids.split("-");
      var spanID = void 0;
      if (aId.length === 2) {
        //两位id处理方式
        spanID = ids;
        var $span = $("#" + spanID);
        that._removeClass($span, category);
      } else if (aId.length === 3) {
        var index = aId.pop();
        for (var i = 0; i < index; i++) {
          spanID = aId.join("-");
          //   console.log(spanID);
          var _$span2 = $("#" + spanID);
          that._removeClass(_$span2, category);
          aId[1]++;
        }
      }
    };
    //标记span标签不高亮
    that.unmarkAllSpans = function (category) {
      var $span = $("#playerContent span");
      if (category) {
        that._removeClass($span, category);
      } else {
        // 没有参数取消全部高亮
        $span.removeAttr("class");
      }
    };
    // 对某个单词进行生词高亮
    that.markSpanWithMap = function (json) {
      if ((typeof json === "undefined" ? "undefined" : _typeof(json)) != "object") {
        // 不为json
        return;
      }
      that.unmarkAllSpans(); //清除以前的高亮记录
      var getIgnoreSign = function getIgnoreSign(value) {
        //忽略空格和大小写
        return value.toLowerCase().replace(/\s/gi, "");
      };
      for (var ids in json) {
        var aId = ids.split("-");
        var html = "";
        var $span = void 0;
        if (aId.length === 2) {
          //两位id处理方式
          $span = $("#" + ids);
          html = $span.html();
        } else if (aId.length === 3) {
          var index = aId.pop();
          var spanID = aId.join("-");
          $span = $("#" + spanID);
          for (var i = 0; i < index; i++) {
            var id = aId.join("-");
            var cellHtml = $("#" + id).html();
            html += cellHtml;
            aId[1]++;
          }
        }
        var value = json[ids];
        // console.log(value);
        // console.log(html);
        if (!!html && getIgnoreSign(html) == getIgnoreSign(value)) {
          that.markSpan(ids, "new-word");
        }
      }
    };
    // 开关生词回顾
    that.switchReview = function (isShow) {
      if (isShow) {
        $("#reviewNewWordWrap").show();
      } else {
        $("#reviewNewWordWrap").hide();
      }
    };
    //标记favorite
    that.favorSentence = function (arr) {
      arr.forEach(function (v) {
        var $sentece = $("#" + v);
        $sentece.addClass("favorite");
      });
    };
    //取消标记favorite
    that.disfavorSentence = function (arr) {
      arr.forEach(function (v) {
        var $sentece = $("#" + v);
        $sentece.removeClass("favorite");
      });
    };
    //设置字号
    that.setFontLevel = function (fontLevel) {
      // $("#playerContentWrap").removeClass("small medium large").addClass(fontLevel);
      $("body").removeClass("small medium large xlarge").addClass(fontLevel);
    };
    //设置主题
    that.setTheme = function (theme) {
      // 先删除主题后添加主题
      $("body").attr("class", function (index, className) {
        return className ? className.replace(/\S+-theme($|\s)/g, "") : "";
      }).addClass(theme);
      var newTheme = theme.replace("-theme", "");
      this.theme = newTheme;
      this.setFollowReadingCover();
    };
    //返回 span id
    that.getSpanAtPoint = function (x, y) {
      var $ele = $(document.elementFromPoint(x, y));
      if ($ele.is("span") && $ele.parents(".lrc").length) {
        return $ele.attr("id");
      } else {
        return "";
      }
    };
    //返回 返回两端的segmentID
    that.getExtremeSegmentId = function () {
      function getScreenFirstObj($lrc) {
        var scrollY = window.scrollY;
        for (var i = 0; i < $lrc.length; i++) {
          var $that = $lrc.eq(i);
          var marginTop = 20;
          var top = $that.offset().top + $that.height() - marginTop;
          //   console.log(top);
          //   console.log(scrollY);
          if (top >= scrollY) {
            return $that;
          }
        }
        return $lrc.eq(0);
      }
      function getScreenLastObj($lrc) {
        var scrollY = window.scrollY + $(window).height();
        var $prev;
        for (var i = 0; i < $lrc.length; i++) {
          var $that = $lrc.eq(i);
          var top = $that.offset().top;
          if (top >= scrollY) {
            return $prev;
          }
          $prev = $that;
        }
        return $lrc.last();
      }
      var $lrc = $("#playerContent .lrc");
      var firstSegmentId = getScreenFirstObj($lrc).attr("id");
      var lastSegmentId = getScreenLastObj($lrc).attr("id");
      var json = {
        firstSegmentId: firstSegmentId,
        lastSegmentId: lastSegmentId
      };
      //   console.log(json);
      return JSON.stringify(json);
    };
    //遍历暂停所有音频视频
    that.pauseAVPlayback = function () {
      $("video,audio").each(function () {
        this.pause();
      });
    };
    //for android start
    that.getWordBySpanId = function (spanID) {
      var $span = $("#" + spanID);
      var json = {};
      json.word = $span.html();
      json.left = $span.offset().left;
      json.right = json.left + $span.width();
      json.top = $span.offset().top;
      json.bottom = json.top + $span.height();
      return JSON.stringify(json);
    };
    that.windowWidth = function () {
      return window.innerWidth;
    };
    that.windowHeight = function () {
      return window.innerHeight;
    };
    that.scrollTo = function (spanID) {
      var $span = $("#" + spanID);
      return $span.offset().top;
    };
    // 获取元素滚动信息，传给客户端
    that.scrollFor = function (segid) {
      var $obj = $("#" + segid);
      var sentenceHeight = $obj.height();
      var objOffset = $obj.offset();
      //   console.log("============log");
      //   console.log(segid);
      //   console.log($obj);
      //   console.log(objOffset);
      if (objOffset) {
        // console.log($(".transing .i18n-lrc"));
        var transHeight = $(".transing .i18n-lrc").data("showHeight"); //单句译文，下一句会折叠，需要减去该高度，
        transHeight = transHeight ? transHeight : 0;
        var previousSentenceHeight = $obj.prev().height(); //上一行句子高度
        previousSentenceHeight ? previousSentenceHeight : 0;
        // 回调安卓客户端，例句高度，offsetTop,上一句例句高度
        window.langeasy.scrollFor(sentenceHeight, objOffset.top - transHeight, previousSentenceHeight);
      }
    };
    // iOS使用，获取上一句例句高度
    that.getPrevSegidHeight = function (segid) {
      var $obj = $("#" + segid);
      var previousSentenceHeight = $obj.prev().height(); //上一行句子高度
      return previousSentenceHeight ? previousSentenceHeight : 0;
    };
    //iOS使用，获取两个句子之间的间距
    that.getTwoSegidSpacingHeight = function (segid) {
      var $obj = $("#" + segid);
      if ($obj.length) {
        var previousSentenceHeight = $obj.prev().height(); //上一行句子高度
        var prevTop = $obj.prev().offset().top; //上一句例句偏移量
        prevTop = prevTop ? prevTop : 0;
        var currentSegidTop = $obj.offset().top;
        currentSegidTop = currentSegidTop ? currentSegidTop : 0;
        return currentSegidTop - prevTop - (previousSentenceHeight ? previousSentenceHeight : 0);
      } else {
        return 0;
      }
    };
    that.getOffsetTop = function (id) {
      var $obj = $("#" + id);
      //   console.log("obj");
      //   console.log($obj);
      if ($obj.length) {
        return $obj.offset().top;
      } else {
        return 0;
      }
    };
    //json转urlParam
    that._parseParam = function (param, key) {
      var paramStr = "";
      if (param instanceof String || param instanceof Number || param instanceof Boolean) {
        paramStr += "&" + key + "=" + encodeURIComponent(param);
      } else {
        $.each(param, function (i) {
          var k = key == null ? i : key + (param instanceof Array ? "[" + i + "]" : "." + i);
          paramStr += "&" + that._parseParam(this, k);
        });
      }
      return paramStr.substr(1);
    };
    //重置高度
    $(window).on("resize", that._setWrapHeight);
    //跳转到客户端forWeb
    $(document).on("click", "[go-client]", function () {
      var aUrl = $(this).attr("go-client").split(",");
      that._goClient(aUrl[0], aUrl[1]);
    });
    //点击image
    $(document).on("click", ".banner-image", function () {
      var $module = $(this).parent(".module");
      var segid = $module.attr("id");
      window.jsInterface.execute("cmd=rich_media_should_play&type=image&segid=" + segid);;
    });
    //点击iframe
    $(document).on("click", ".iframe-mask", function () {
      var $module = $(this).parent(".module");
      var segid = $module.attr("id");
      window.jsInterface.execute("cmd=rich_media_should_play&type=iframe&segid=" + segid);;
    });
    //跳转到客户端forClient
    $(document).on("click", "[open-url]", function () {
      var aUrl = $(this).attr("open-url").split("|");
      var url = "";
      for (var i = 0; i < aUrl.length; i++) {
        if (i == 0) {
          url += "preferred=" + encodeURIComponent(aUrl[0]);
        } else if (i == 1) {
          url += "&backup=" + encodeURIComponent(aUrl[1]);
        }
      }
      //   console.log(url);
      window.jsInterface.execute("cmd=open_url&" + url);;
    });
    that._jsonToParam = function (json) {
      return Object.keys(json).map(function (key) {
        return encodeURIComponent(key) + "=" + encodeURIComponent(json[key]);
      }).join("&");
    };
    $(document).on("touchend", "[to-client]", function () {
      var jsonPar = $(this).attr("to-client");
      var par = that._jsonToParam($.parseJSON(jsonPar));
      console.log(par);
      window.jsInterface.execute(par);;
    });
    $.isAndroid = function () {
      if (window.navigator.userAgent.match(/android/i)) {
        return true;
      }
      return false;
    };
    /**
     * 执行客户端指令
     * @param {String} str
     */
    that.executeCmd = function (str) {
      console.log(str);
      if ($.isAndroid()) {
        if (window.jsInterface) {
          window.jsInterface.execute(str);
        }
      } else {
        if (window.webkit) {
          var arr = str.split("&");
          var aCmd = arr[0].split("=");
          var cmd = aCmd[1];
          var extend = str.replace(arr[0] + "&", "");
          window.webkit.messageHandlers[cmd].postMessage(extend);
        } else {
          window.location.href = "js2oc://?" + str;
        }
      }
    };
    /**
     * 以对象方式运行客户端命令，
     * @param {Object} obj
     */
    that.executeCmdByObj = function (obj) {
      // 只有iOS不背url中有多个参数会出现&符号需要encodeUri两次
      var isLexis = BaseUtil.checkAppName() === "lexis";
      if (!$.isAndroid() && isLexis) {
        var cmd = Object.keys(obj).map(function (key) {
          return key + "=" + encodeURIComponent(encodeURIComponent(obj[key]));
        }).join("&");
        that.executeCmd(cmd);
      } else {
        var _cmd = Object.keys(obj).map(function (key) {
          return key + "=" + encodeURIComponent(obj[key]);
        }).join("&");
        that.executeCmd(_cmd);
      }
    };
    /**
     * 推荐执行客户端指令
     * @param {String} cmd
     * @param {Object} obj
     * @returns {Promise}
     */
    that.executeCmdParam = function (cmd) {
      var obj = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      obj.cmd = cmd;
      that.executeCmdByObj(obj);
      return new Promise(function (resolve) {
        setTimeout(function () {
          resolve();
        }, 100);
      });
    };
    // 待删除
    that._doNativeAction = function (cmd, extend) {
      var newCmd = cmd;
      if (extend) {
        newCmd = cmd + "&" + extend;
      }
      if ($.isAndroid()) {
        if (window.jsInterface) {
          window.jsInterface.execute(newCmd);
        }
      } else {
        if (window.webkit) {
          window.webkit.messageHandlers[cmd].postMessage(extend);
        } else {
          window.location.href = "js2oc://?" + newCmd;
        }
      }
    };
    /**
     * 显示跟读模块
     * @param cover:String 封面
     * @param title:String 标题
     * @param text:String 副标题
     * @param btnText:String 按钮描述
     */
    that.renderFollowReading = function (cover, title, text, btnText) {
      console.log("renderFollowReading...");
      var $followReadingContainer = $("#followReadingContainer");
      $followReadingContainer.find("dt").html(title);
      $followReadingContainer.find("dd").html(text);
      $followReadingContainer.find(".btn").html(btnText);
      this.followReadingCover = cover;
      this.setFollowReadingCover();
      $followReadingContainer.show();
    };
    /**
     * 显示切歌模块
     * @param prev:String 上一曲
     * @param next:String 下一曲
     */
    that.renderSkinEpisode = function (jsonstr) {
      var json = jsonstr;
      if ((typeof jsonstr === "undefined" ? "undefined" : _typeof(jsonstr)) != "object") {
        json = JSON.parse(jsonstr);
      }
      var _json = json,
          prev = _json.prev,
          next = _json.next;

      if (!prev && !next) {
        $("#skipEpisodeWrap").hide();
        return;
      } else {
        var $skipEpisodeWrap = $("#skipEpisodeWrap").css({ display: "flex" });
        if (prev) {
          $skipEpisodeWrap.find(".prev-wrap").show().find("dd").html(prev);
        } else {
          $skipEpisodeWrap.find(".prev-wrap").hide();
        }
        if (next) {
          $skipEpisodeWrap.find(".next-wrap").show().find("dd").html(next);
        } else {
          $skipEpisodeWrap.find(".next-wrap").hide();
        }
      }
    };
    // 设置跟读模块封面
    that.setFollowReadingCover = function () {
      var cover = _this.followReadingCover;
      if (!cover) {
        return;
      }
      var theme = _this.theme;
      var fileExtension = cover.split(".").pop();
      //ex:.jpg 替换 _light.jpg
      var url = void 0;
      console.log({ theme: theme });
      if (that.appName !== that.LEXIS_APP_NAME && theme === "dark") {
        url = cover.replace("." + fileExtension, "_nig." + fileExtension);
      } else if (theme === "default") {
        url = cover;
      } else {
        url = cover.replace("." + fileExtension, "_" + theme + "." + fileExtension);
      }
      var fullUrl = BaseUtil.imgCdn + "/" + url;
      $("#followReadingContainer img").attr("src", fullUrl);
    };
    // 跟读按钮跳转
    $(document).on("touchend", "#followReadingContainer", function () {
      console.log("follow_reading");
      that._doNativeAction("cmd=follow_reading");
    });
    // 去回顾生词
    $(document).on("touchend", "#reviewNewWordWrap .btn", function () {
      console.log("reviewNewWordWrap...");
      that._doNativeAction("cmd=review_new_word_wrap");
    });
    // todo:格式化时间
    var formatTime = function formatTime(time) {
      var minutes = Math.floor(time / 60);
      var seconds = Math.floor(time % 60);
      return (minutes < 10 ? "0" + minutes : minutes) + ":" + (seconds < 10 ? "0" + seconds : seconds);
    };
    // todo:添加mpvoice事件
    var playIngAudio = void 0;
    that.addMpvoiceEvent = function () {
      var aMpvoice = document.querySelectorAll("mpvoice,mp-common-mpaudio");
      // 可视范围事件
      var observer = new IntersectionObserver(function (entries) {
        entries.forEach(function (entry) {
          var target = entry.target;
          var parent = target.parentNode;
          if (entry.isIntersecting && parent.classList.contains("fixed")) {
            parent.classList.remove("fixed");
          }
          if (!entry.isIntersecting && parent.classList.contains("mpvoice-playing")) {
            parent.classList.add("fixed");
          }
        }, {
          threshold: [0, 0.25, 0.5, 0.75, 1]
        });
      });
      aMpvoice.forEach(function (item) {
        item.classList.add("mpvoice-active");
        var src = item.getAttribute("src");
        var name = item.getAttribute("name");
        var searchParams = new URLSearchParams(src.split("?")[1]);
        var playLength = searchParams.get("play_length");

        var _playLength$split$map = playLength.split(":").map(function (v) {
          return parseInt(v);
        }),
            _playLength$split$map2 = _slicedToArray(_playLength$split$map, 2),
            minutes = _playLength$split$map2[0],
            seconds = _playLength$split$map2[1];

        var timeInSeconds = minutes * 60 + seconds;
        var mediaid = item.getAttribute("voice_encode_fileid");
        var audioLink = "https://res.wx.qq.com/voice/getvoice?mediaid=" + mediaid;
        var template = "\n        <div class=\"placeholder\"></div>\n        <section class=\"play-container\">\n          <p class=\"name\">" + name + "</p>\n          <div class=\"audio-wrap\">\n              <audio src=\"" + audioLink + "\"></audio>\n            </div>\n          <div class=\"play-wrap\">\n            <div class=\"btn\"></div>\n            <div class=\"play-bar-wrap\">\n              <div class=\"bar-wrap\">\n                <input type=\"range\" min=\"0\" value=\"0\" max=\"" + timeInSeconds + "\" />\n              </div>\n              <div class=\"time-wrap\">\n                <span class=\"start-time\">00:00</span>\n                <span class=\"end-time\">" + playLength + "</span>\n              </div>\n            </div>\n          </div>\n        </section>";
        item.innerHTML = template;
        var audio = item.querySelector("audio");
        var btn = item.querySelector(".btn");
        btn.addEventListener("click", function (event) {
          event.stopPropagation();
          if (audio.paused) {
            audio.play();
          } else {
            audio.pause();
          }
        });
        audio.addEventListener("play", function () {
          btn.classList.add("playing");
          item.classList.add("mpvoice-playing");
          playIngAudio = audio;
          window.jsInterface.execute("cmd=rich_media_did_play");;
        });
        audio.addEventListener("pause", function () {
          btn.classList.remove("playing");
          item.classList.remove("mpvoice-playing");
          window.jsInterface.execute("cmd=rich_media_did_pause");;
        });
        audio.addEventListener("ended", function () {
          btn.classList.remove("playing");
          item.classList.remove("mpvoice-playing");
        });
        // input修改
        var input = item.querySelector("input");
        input.addEventListener("input", function () {
          var currentTime = input.value;
          audio.currentTime = currentTime;
        });
        // 更新时间
        var hasEndTime = false;
        audio.addEventListener("timeupdate", function () {
          var input = item.querySelector("input");
          var currentTime = audio.currentTime;
          input.value = currentTime;
          var duration = audio.duration;
          input.setAttribute("max", duration);
          var aSpan = item.querySelectorAll(".time-wrap span");
          var startTime = item.querySelector(".start-time") || aSpan[0];
          if (!hasEndTime) {
            var endTime = item.querySelector(".end-time") || aSpan[1];
            hasEndTime = true;
            var _duration = audio.duration;
            endTime.innerText = formatTime(_duration);
          }
          startTime.innerText = formatTime(currentTime);
        });
        {
          var playContainer = item.querySelector(".play-container");
          playContainer.style.top = "0px"; //悬浮播放器顶部距离
        }
        {
          // 添加滚动条事件
          var placeholder = item.querySelector(".placeholder");
          placeholder.style.top = "-0px"; //悬浮播放器顶部距离
          observer.observe(placeholder);
        }
      });
      // aMpvoice[0].classList.add('fixed');
    };
    // 长按查词
    that.longPressSelectWord = function () {
      $(document).on("touchstart", function () {
        window.getSelection().removeAllRanges();
      });
      var lastValue = void 0; //最后选中值
      var postSelectionChange = function postSelectionChange(ev) {
        if (window.getSelection().toString() && lastValue != window.getSelection().toString()) {
          var word = window.getSelection().toString();
          var position = 0;
          if (word) {
            that._doNativeAction("cmd=pop_word", "word=" + word + "&position=" + position);
            playIngAudio && playIngAudio.pause();
            ev.preventDefault();
          }
        } else {
          lastValue = '';
        }
      };
      // selectionChange
      var moveTimer = null;
      var isResume = void 0;
      var selectionChange = function selectionChange(ev) {
        console.log('selectionChange');
        if (isResume) {
          setTimeout(function () {
            isResume = false;
          }, 100);
          return;
        }
        moveTimer && clearTimeout(moveTimer);
        moveTimer = setTimeout(function () {
          postSelectionChange(ev);
        }, 300);
      };
      document.addEventListener('selectionchange', selectionChange, false);
    };
    // 显示原文
    // const CMD_SHOW_EPISODE_CONTENT = "show_episode_content"; // cmd=show_episode_content
    // $(document).on("touchend", "#showEpisodeTips", function () {
    //   that.executeCmdParam(CMD_SHOW_EPISODE_CONTENT);
    // });
    that.clearScreen();
    that.longPressSelectWord();
  }
};
episode._init();
window.jsInterface.execute("cmd=load_webview_did");;

;