"use strict";

(function ($) {
  // 实现点：
  //_检测视频是否能够播放
  //_视频初始化
  //_播放停止，弹出进度条，并暂停按钮
  //_播放暂停，
  //_播放
  //_媒体长度改变 ondurationchange
  //_缓存进度 onprogress
  //_播放进度更新 ontimeupdate
  //_全屏
  //_兼容 audio
  //_改成zepto插件
  $.fn.bannerPlayer = function (options) {
    var defaults = {
      type: "video"
    };
    options = $.extend(defaults, options);
    var that = this;
    var $playerWrap = $(this);
    var type = options.type == "video" ? "movie" : "audio";
    var oPlayer = $playerWrap.find(type)[0];
    !oPlayer && (oPlayer = { addEventListener: function addEventListener() {} });
    oPlayer && (oPlayer.bCanPlay = false);
    var $extraContent = $playerWrap.find(".extra-content");
    var $btnPlayer = $extraContent.find(".btn-player");
    var $posterWrap = $extraContent.find(".poster-wrap");
    var $ctrlContent = $playerWrap.find(".ctrl-content");
    var $btnFullScreen = $playerWrap.find(".btn-fullScreen");
    var $elapse = $ctrlContent.find(".elapse");
    var $duration = $ctrlContent.find(".duration");
    var $smallPlayer = $ctrlContent.find(".btn-player");
    var $processContent = $ctrlContent.find(".process-content");
    // var $processBar = $ctrlContent.find(".process-bar");
    var $bufferBar = $ctrlContent.find(".buffer-bar");
    var $pauseTimer = null;
    var draging = false;
    // console.log("loaded zepto插件 in");
    //时间格式转换
    this.tranTime = function (time) {
      time = Math.floor(time);
      var minute = parseInt(time / 60);
      var second = time % 60 >= 10 ? "" + time % 60 : "0" + time % 60;
      return minute + ":" + second;
    };
    // 间隔隐藏
    this.timeoutHideInfo = function () {
      var that = this;
      clearInterval(that.pauseTimer);
      that.pauseTimer = setTimeout(function () {
        if (!oPlayer.paused) {
          that.hideInfo();
        }
      }, 8000);
    };
    //视频状况
    this.doState = function () {
      var that = this;
      // console.log("=========oPlayer=======");
      // console.log(oPlayer);
      if (!oPlayer) {
        return false;
      }
      oPlayer.addEventListener("ended", function () {
        that.doStop();
      });
      oPlayer.addEventListener("durationchange", function () {
        $duration.html(that.tranTime(oPlayer.duration));
        // console.log("$player");
        // console.log(oPlayer);
        // that.goBuffer();
      });
      oPlayer.addEventListener("seeking", function () {
        // that.goBuffer();
      });
      oPlayer.addEventListener("play", function () {
        if (!this.bCanPlay) {
          oPlayer.pause();
        } else {
          this.bCanPlay = false;
        }
      });
      oPlayer.addEventListener("timeupdate", function () {
        // that.goBuffer();
        if (!draging) {
          that.goProcess();
        }
        $duration.html(that.tranTime(oPlayer.duration));
      });
      oPlayer.addEventListener("pause", function () {
        that.showInfo();
        $smallPlayer.removeClass("paused");
        window.jsInterface.execute("cmd=rich_media_did_pause");;
      });
    };
    //进度条显示
    this.goProcess = function () {
      var currentTime = oPlayer.currentTime;
      var duration = Math.floor(oPlayer.duration * 10);
      $processContent.attr("max", duration);
      that.updateProcessBar(currentTime);
    };
    //更新进度条
    this.updateProcessBar = function (currentTime) {
      var duration = oPlayer.duration;
      var percent = currentTime / duration * 100;
      $processContent.val(currentTime * 10);
      $elapse.html(that.tranTime(Math.floor(currentTime)));
      var appName = BaseUtil.checkAppName();
      var isQlisten = appName === BaseUtil.QLISTEN_APP_NAME;
      //不同应用配色
      var colorConfig = {
        qlisten: {
          light: "#1ec07f",
          dark: "#136f53"
        },
        langeasy: {
          light: "#f1a219",
          dark: "#b47a13"
        }
      };
      var oColor = isQlisten ? colorConfig["qlisten"] : colorConfig["langeasy"];
      if ($("body").hasClass("dark-theme")) {
        $processContent.css("background-image", "-webkit-linear-gradient(left ," + oColor.dark + " 0%," + oColor.dark + " " + percent + "%,rgba(255,255,255,0.22) " + percent + "%, rgba(255,255,255,0.22) 100%)");
      } else {
        $processContent.css("background-image", "-webkit-linear-gradient(left ," + oColor.light + " 0%," + oColor.light + " " + percent + "%,rgba(0,0,0,0.26) " + percent + "%, rgba(0,0,0,0.26) 100%)");
      }
    };
    //读取缓存
    this.goBuffer = function () {
      var contentWidth = $processContent.width();
      var buffered = oPlayer.buffered.end(0);
      var duration = oPlayer.duration;
      //   console.log(oPlayer);
      //   console.log(oPlayer.buffered.end(0));
      $bufferBar.width(buffered / duration * contentWidth);
    };
    //隐藏信息
    this.hideInfo = function () {
      //   console.log("hideInfo");
      $extraContent.addClass("hide");
      $ctrlContent.addClass("hide");
    };
    //显示信息
    this.showInfo = function () {
      clearInterval($pauseTimer);
      $extraContent.removeClass("hide");
      $ctrlContent.removeClass("hide");
    };
    //播放
    this.doPlay = function () {
      oPlayer && (oPlayer.bCanPlay = true);
      //没有视频音频在播放了记录状态
      $("audio").each(function () {
        this.pause();
      });
      if (options.type == "audio") {
        window.jsInterface.execute("cmd=rich_media_did_play");;
      } else {
        var segid = $playerWrap.parents(".module").attr("id");
        window.jsInterface.execute("cmd=rich_media_should_play&type=video&segid=" + segid);;
        return false;
      }
      if (options.type == "audio" && !oPlayer.duration) {
        var src = $playerWrap.find(options.type).attr("src");
        $playerWrap.find(options.type).attr("src", "");
        oPlayer = $playerWrap.find(options.type).attr("src", src)[0];
        // console.log("========oPlayer=======");
        // console.log(oPlayer);
        oPlayer.bCanPlay = true;
        // that.doState();
      }
      // if(!$player.loaded){
      //         $player[0].play();
      // }
      //
      // $player.loaded = true;
      // if(!loaded){
      //         setTimeout(function(){
      //             $smallPlayer[0].click();
      //         },1000);
      //         loaded = true;
      // }
      $posterWrap.hide();
      $btnPlayer.hide();
      oPlayer.play();
      $smallPlayer.addClass("paused");
      that.timeoutHideInfo();
      // window.jsInterface.execute("cmd=playback_pause");
      return false;
    };
    //暂停
    this.doPause = function () {
      oPlayer.pause && oPlayer.pause();
      $smallPlayer.removeClass("paused");
      that.showInfo();
    };
    //停止
    this.doStop = function () {
      $btnPlayer.show();
      that.doPause();
      $smallPlayer.removeClass("paused");
      setTimeout(function () {
        that.updateProcessBar(0);
        // window.jsInterface.execute("cmd=playback_restore");
      }, 1000);
    };
    //同步更新视频
    $processContent.on("change", function () {
      that.updateProcessBar(this.value / 10);
    });
    // 点击定位 与 拖拽
    $processContent.on("touchstart", function () {
      var currentTime = $processContent.val() / 10;
      draging = true;
      clearInterval($pauseTimer);
      $processContent.on("touchmove", function () {
        currentTime = $processContent.val() / 10;
        oPlayer.currentTime = currentTime;
        that.updateProcessBar(currentTime);
        draging = true;
        clearInterval($pauseTimer);
        // return false;
      });
      $processContent.on("touchend", function () {
        currentTime = $processContent.val() / 10;
        oPlayer.currentTime = currentTime;
        that.updateProcessBar(currentTime);
        draging = false;
        that.timeoutHideInfo();
        // return false;
      });
      // return false;
    });
    //全屏
    $btnFullScreen.on("click", function () {
      //   console.log(oPlayer);
      if (oPlayer.requestFullscreen) {
        oPlayer.requestFullscreen();
      } else if (oPlayer.mozRequestFullScreen) {
        oPlayer.mozRequestFullScreen();
      } else if (oPlayer.webkitRequestFullscreen) {
        oPlayer.webkitRequestFullscreen();
      } else if (oPlayer.webkitEnterFullScreen) {
        oPlayer.webkitEnterFullScreen();
      }
      return false;
    });
    //点击显示导航条
    // $playerWrap.on("click", function() {
    //
    //     console.log("点击显示导航条");
    //     console.log($processContent.val());
    //
    //     if (oPlayer.paused) {
    //         return false;
    //     }
    //
    //     if ($ctrlContent.hasClass("hide")) {
    //         that.showInfo();
    //         that.timeoutHideInfo();
    //     } else {
    //         that.hideInfo();
    //     }
    //
    //     return false;
    // });
    //点击播放
    $playerWrap.on("click", function () {
      //   console.log("全屏都可以点击播放");
      if (options.type == "video") {
        // console.log("全屏都可以点击播放2");
        that.doPlay();
      }
    });
    $smallPlayer.on("click", function () {
      console.log("播放按钮");
      if (oPlayer.paused) {
        console.log("播放");
        that.doPlay();
      } else {
        console.log("暂停");
        that.doPause();
        // window.jsInterface.execute("cmd=playback_restore");
      }
      return false;
    });
    this.doState();
  };
})($);